var carousel = null;

function bridgeData(caller) {
    $('#container').empty();
    TWCmod.getData('live');
    Legacy.carousel.showPane(0);

}

function onSettle() {
    console.log('settling');;
}

function onScroll() {
    console.log('scrolling');
}

var myimages = new Array()

function preloadimages() {
    for (i = 0; i < preloadimages.arguments.length; i++) {
        myimages[i] = new Image()
        myimages[i].src = preloadimages.arguments[i]
    }
}

preloadimages("css/images/navOff_03.png", "css/images/navOn_06.png")


var isMobile = navigator.userAgent.match(/Android/i) || navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPad/i) || navigator.userAgent.match(/iPod/i);

window.resArray = [];
window.contWidth = 0;
window.carouselVer = 'new';

// $(function () {
//     FastClick.attach(document.body);
// });


// Ice Cream Sandwich transparent background fix
if (isMobile) {
    var input = isMobile.input;
    var android = input.indexOf('Android');
    var androidPlus = android + 8;

    var version = input.slice(androidPlus, android + 11);


    if (version <= 4.1) {
        var carouselVer = 'old';
    }
}

//KitKat blank module fix - KitKat triggers a resize event after setting body to 0px
$(window).resize(function () {
    TWCmod.setupView();
});

function calibrateScale() {
    var $html = $('html');
    $html.css('font-size', $(window).width() / 21.3);
    $('body').css('font-size', $(window).width() / 21.3);
};


var TWCmod = {

    setupView: function setupView() {
        var $html = $('html');
        $html.css('font-size', $(window).width() / 21);
        $('body').css('font-size', $(window).width() / 21);
        TWCmod.clearData();
        TWCmod.relSize();
        TWCmod.getData('live');
        TWCmod.activeView = "departures";
        TWCmod.viewNav();
    },

    relSize: function relSize() {

        var winWidth = $(window).width(),
            winHeight = $(window).height(),
            navWidth = winWidth * .2,
            headerHeight = winWidth * .125,
            contentHeight = winWidth * 1;
        if (navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPod/i)) {

            $('.circleHigh').css('margin-right', '-12%');
        }

        $('header').height(headerHeight);
        $('#leftPane li.navItem').width(navWidth).height(navWidth);
        $('#content, #modType, .modType, .content').height(contentHeight * .95).width(contentHeight * .95);
        $('#content').height(contentHeight * 1);

        $('.circle').each(function (index) {
            circleW = $(this.index).width();
            $('.circle').height(circleW);
        });
    },

    viewNav: function viewNav() {
        if (isMobile) {
            function mobileNav() {
                $('.navItem').on('touchend', function (e) {

                    var navTitle = $(this).attr('title');
                    TWCmod.activeView = navTitle;

                    $('#container .modType.' + navTitle).show().siblings('.modType').hide();
                    $('#carousel .modType.' + navTitle).show().siblings('.modType').hide();
                    $(this).siblings().removeClass('selected');
                    $(this).addClass('selected');
                    e.preventDefault();

                }.throttle(300));
            };
            mobileNav();
        } else {
            function desktopNav() {
                $('.navItem').on('click', function () {
                    //alert('click');
                    var navTitle = $(this).attr('title');
                    $('#container .modType.' + navTitle).show().siblings('.modType').hide();
                    $(this).siblings().removeClass('selected');
                    $(this).addClass('selected');
                });
            };
            desktopNav();
        }
    },

    getData: function getData(mode) {

        $(window).css('background-color', 'transparent');
        $(document).css('background-color', 'transparent');
        $('body').css('background-color', 'transparent');
        TWCmod.clearData();
        //mode = "test";
        //mode = "live";
        if (mode !== "test") {
            try {

                var data = Android.getData();

                parseData = $.parseJSON(data);

                TWCmod.checkData(parseData);


            } catch (e) {
                //console.log(e);
                TWCmod.noData('live mode catch');
            }

        } else {
            try {


                $.ajax({
                    //had CORS problem
                    type: 'GET',
                    url: 'data/data.json',
                    headers: {
                        'Access-Control-Allow-Origin': '*'
                    },
                    crossDomain: true,
                    dataType: "HTML",
                    success: function (data) {
                        data = JSON.parse(data);

                        TWCmod.checkData(data)
                        //createElArray(data)
                    },
                    error: function () {
                        console.log('didnt get json locally')
                    }
                });

            } catch (e) {
                console.log(e.stack);
                TWCmod.noData(111);
            }
        }

    },

    noData: function noData(loader) {
        TWCmod.clearData();
        var modName = 'airport';
        $('.airports .modName').text(modName);
        $('.airports .dataVis').hide();
        $('#leftPane').hide();
        setTimeout(function () {
            $('.airports .noData').show();
        }, 1000);
    },

    checkData: function checkData(response) {

        resArray.length = 0;

        $(response).each(function (index) {
            //console.log(response[index]);
            if (typeof response === 'undefined' || !response.length || response === '') {
                console.log('No data was returned.');
                TWCmod.noData(158);
            } else {

                if (response.isEmptyObject) {
                    // console.log('Empty JSON');
                    TWCmod.noData(85);
                } else if (response.length === 0) {
                    // console.log('Empty Array');
                    TWCmod.noData(91);
                } else if (response[index] === null || response[index] === "Not Found" || response[index] === "NotFound" || response[index].status === 404 || response[index].status === 204) {
                    //console.log('Data was null');
                    TWCmod.noData(91);
                } else if (typeof response === "undefined") {
                    // console.log('Data was undefined');
                    TWCmod.noData(95);
                } else {

                    if (response[index].departure && response[index].code && response[index].arrival) {
                        resArray.push(response[index]);

                    }

                }
            }

        });

        if (resArray.length < 1) {
            TWCmod.noData('resArray empty');
        } else {
            //Populate.populateData(resArray);
            if (carouselVer == 'new') { createElArray(resArray); $('#carousel').hide(); } else {Populate.populateData(resArray); $('#container').hide();} 
        }
    },

    clearData: function clearData(response) {
        $('.panelList').empty();
        $('.airports .pageDots').empty();
        $('.airports .noData').hide();
        //$('.airports .dataVis').css('opacity', '1');
        $('.airports .dataVis').show();
        $('#leftPane').show();
        $('.current .modType.departures').show().siblings('.modType').hide();
        $('#leftPane').css({
            'z-index': '2000',
            'opacity': '1'
        });
    }
};

function createElArray(data) {

            var elArray =[];
            $(data).each(function (index, element) {
                var uvInd = '<div class="modType departures selected condition-module"><div class="circleHigh circle"><div class="circleMap circle"><div class="details"><span class="unit uvi">UV Index: <span class="dlevel">' + this.observation.uv.index + '</span></span>',
                dew = '<span class="unit dew">Dew Point: <span class="dlevel">' + this.observation.dewPoint + '</span></span>',
                hum = '<span class="unit hum">Humidity: <span class="dlevel">' + this.observation.relativeHumidity + '</span></span>',
                vis = '<span class="unit vis">Visibility: <span class="dlevel">' + this.observation.visibility + '</span></span>',
                pres = '<span class="unit pre">Pressure: <span class="dlevel">' + this.observation.pressure.pressure + '</span></span>',
                wind = '<span class="unit win">Wind: <span class="direction"></span><span class="dlevel">' + this.observation.wind.speed + '</span> </span></div>',
                delay = '<div class="circleLow circle"><div class="levelDisplay"><div class="disc">Average Delay</div><span class="clr"></span><div class="num"><span class="actNum">' + this.departure.delay + '</span><span><small style="color:white;"> Min</small></span></div></div></div></div></div></div>',
                tideUv = '<div class="modType arrivals condition-module"><div class="circleHigh circle"><div class="circleMap circle"><div class="details"><span class="unit uvi">UV Index:<span class="dlevel">' + this.observation.uv.index + '</span></span>',
                tideDew = '<span class="unit dew">Dew Point: <span class="dlevel">' + this.observation.dewPoint + '</span></span>',
                tideHum = '<span class="unit hum">Humidity: <span class="dlevel">' + this.observation.relativeHumidity + '</span></span>',
                tideVis = '<span class="unit vis">Visibility: <span class="dlevel">' + this.observation.visibility + '</span></span>',
                tidePres = '<span class="unit pre">Pressure: <span class="dlevel">' + this.observation.pressure.pressure + '</span></span>',
                tideWind = '<span class="unit win">Wind: <span class="direction"></span><span class="dlevel">' + this.observation.wind.speed + '</span> </span></div>',
                tideDelay = '<div class="circleLow circle"><div class="levelDisplay"><div class="disc">Average Delay</div><span class="clr"></span><div class="num"><span class="actNum">' + this.departure.delay + '</span><span><small style="color:white;"> Min</small></span></div></div></div></div></div></div>';
                

            elArray.push('<div class="panel'+ index + '"><h2>' + this.name + ', ' + this.code + '</h2>' + uvInd + dew + hum  + vis + pres + wind + delay + tideUv + tideDew + tideHum  + tideVis + tidePres + tideWind + tideDelay + '</div>');
            $('.pageDots').append('<span class="circle dot' + index + '"></span>');
            $('.pageDots .dot0').addClass('selected').siblings().removeClass('selected');
                
            });


var firstEl = $(elArray[0]);
$('#container').prepend(firstEl);

$('.navItem.departures').addClass('selected').siblings().removeClass('selected');

TWCmod.viewNav();

var carousel = new Carousel("#carousel", elArray);

}
function Carousel(element, elarray)
    {
        var self = this;
        // element = $(element);
        var arrLen = elarray.length;

        var container = $("#container");
        var pane = $(">div", container);
        //console.log(pane[0].className);
        var pane_width = pane.width();

        new Hammer(pane[0], { dragLockToAxis: true }).on("release dragleft dragright swipeleft swiperight", handleHammer);



        function setContainerOffset(percent, animate) {


            pane.css("transform", "translate3d("+ percent +"px,0,0) scale3d(1,1,1)");

        }

        this.next = function() { 
            var nextPaneClass = pane[0].className;

            var nextPaneClassIndex = nextPaneClass.slice(5, nextPaneClass.length);
 
            var nextPaneNum = parseInt(nextPaneClassIndex,10);

            var paneNumInc = nextPaneNum + 1;

            if(paneNumInc < arrLen){

            //var paneAnim = $('.panel' + paneNumInc);
            var nextEl = $(elarray[paneNumInc]);
            var nextElDiv = $(nextEl[0]);
            $(nextElDiv).addClass('panel');
            $('#container').empty().append(nextElDiv);
            $(nextElDiv).animate({left: "-=100%"}, 200,'swing');
            $('#container .modType.departures').show().siblings('.modType').hide();
            $('.navItem.departures').addClass('selected').siblings().removeClass('selected');
            $('.pageDots .dot' + paneNumInc).addClass('selected').siblings().removeClass('selected');
            var dragEl = $(">div", container);
            pane = dragEl;
            $(dragEl[0]).removeClass('pushRight');

        new Hammer(dragEl[0], { dragLockToAxis: true }).on("release dragleft dragright swipeleft swiperight", handleHammer);
    } else {

        $(pane).animate({ whyNotToUseANonExistingProperty: 300}, {
            step: function(now,fx) {
                $(this).css('-webkit-transform',"translate3d(0px, 0px, 0px)");
            },
            duration:'slow'
        },'swing');
    }

         };
        this.prev = function() {


            var currPane = pane[0];

            var nextPaneClass = pane[0].className;

            var nextPaneClassIndex = nextPaneClass.slice(5, nextPaneClass.length);

            var nextPaneNum = parseInt(nextPaneClassIndex,10);
 
            var paneNumInc = nextPaneNum - 1;



            if(paneNumInc > 0){
            //var paneAnim = $('.panel' + paneNumInc);
            var nextEl = $(elarray[paneNumInc]);
            var nextElDiv = $(nextEl[0]);
            $(nextElDiv).addClass('panelLeft');

            $('#container').empty().append(nextElDiv);
            $(nextElDiv).animate({left: "+=100%"}, 200,'swing');
            $('#container .modType.departures').show().siblings('.modType').hide();
            $('.navItem.departures').addClass('selected').siblings().removeClass('selected');
            $('.pageDots .dot' + paneNumInc).addClass('selected').siblings().removeClass('selected');

            var dragEl = $(">div", container);
            pane = dragEl;


        new Hammer(dragEl[0], { dragLockToAxis: true }).on("release dragleft dragright swipeleft swiperight", handleHammer);
    } else if (paneNumInc == 0){
            //var paneAnim = $('.panel' + paneNumInc);
            var nextEl = $(elarray[paneNumInc]);
 
            var nextElDiv = $(nextEl[0]);
            var nextElDiv = nextElDiv[0];
            $(nextElDiv).addClass('panelLeft');
            var initPanel = $('.panel');
            $('#container').empty().append(nextElDiv);
            $(nextElDiv).animate({left: "+=100%"}, 100,'swing');
            $('#container .modType.departures').show().siblings('.modType').hide();
            $('.navItem.departures').addClass('selected').siblings().removeClass('selected');
            $('.pageDots .dot' + paneNumInc).addClass('selected').siblings().removeClass('selected');

            var dragEl = $(">div", container);
            pane = dragEl;


        new Hammer(dragEl[0], { dragLockToAxis: true }).on("release dragleft dragright swipeleft swiperight", handleHammer)
    } else {

        $(pane).removeClass('panelLeft');
        $(pane).animate({ aNonExistingProperty: 300}, {
            step: function(now,fx) {
                $(this).css('-webkit-transform',"translate3d(0px, 0px, 0px)");
            },
            duration:'slow'
        },'swing');
    }
    

         };


        function handleHammer(ev) {
            // disable browser scrolling
            ev.gesture.preventDefault();

            switch(ev.type) {
                case 'dragright':
                case 'dragleft':

                    var drag_offset = (ev.gesture.deltaX);

  

                    setContainerOffset(drag_offset);
                    break;

                case 'swipeleft':
                    self.next();
                    ev.gesture.stopDetect();
                    break;

                case 'swiperight':
                    self.prev();
                    ev.gesture.stopDetect();
                    break;

                case 'release':
                    // more then 50% moved, navigate
                    if(Math.abs(ev.gesture.deltaX) > pane_width/6) {
                        if(ev.gesture.direction == 'right') {
                            self.prev();
                        } else {
                            self.next();
                        }
                    }
                    else {
                        //self.showPane(current_pane, true);
                        $(pane).animate({ aNonExistingProperty: 300}, {
                            step: function(now,fx) {
                                $(this).css('-webkit-transform',"translate3d(0px, 0px, 0px)");
                            },
                            duration:'slow'
                        },'linear');
                    }
                    break;
            }
        }
        // new Hammer(pane[0], { dragLockToAxis: true }).on("release dragleft dragright swipeleft swiperight", handleHammer);
    }


var Populate = {
    populateData: function populateData(response) {

        //response = $.parseJSON(response);

        /*Creates an abreviated day of the week and assigns it to today*/
        var data = response;


        TWCmod.clearData();

        $(data).each(function (index, element) {
            /*Creates a new swipe panel with a copy of the layout template for each item in the JSON data*/
            var template = $('.template').html(),
                thisPanel = '.airports .panel' + index;
            $('.airports .panelList').append('<li class="panel' + index + '">' + template + '</li>');
            if (data.length > 1) {
                $('.pageDots').append('<span class="circle dot' + index + '"></span>');
            }

            /*Populates each panel layout with it's data*/

            $(thisPanel + ' h2').empty().prepend(this.name + ", " + this.code);
            $(thisPanel + ' .departures .actNum').empty().prepend(this.departure.delay).append('<small style="color:white;"> Min</small>');
            //$(thisPanel + ' .departures .nUnit').empty().prepend('Min.');
            $(thisPanel + ' .arrivals .actNum').empty().prepend(this.arrival.delay).append('<small style="color:white;"> Min</small>');
            //$(thisPanel + ' .arrivals .nUnit').empty().prepend('Min.');
            $(thisPanel + ' .uvi .dlevel').empty().prepend(this.observation.uv.index);
            $(thisPanel + ' .dew .dlevel').empty().prepend(this.observation.dewPoint);
            $(thisPanel + ' .hum .dlevel').empty().prepend(this.observation.relativeHumidity);
            $(thisPanel + ' .vis .dlevel').empty().prepend(this.observation.visibility);
            $(thisPanel + ' .pre .dlevel').empty().prepend(this.observation.pressure.pressure);
            $(thisPanel + ' .win .dlevel').empty().prepend(this.observation.wind.speed);
            $(thisPanel + ' .win .direction').empty().prepend(this.observation.wind.directionCardinal);

            /*Initiate the swipe functionality once all the panel have been created*/
            if (index === data.length - 1) {

                carousel = new Legacy.carousel("#carousel");
                carousel.init();

            }
        });
        data = null;
    }
};

var Legacy = {
    carousel: function carousel(element) {

    var self = this;
    element = $(element);

    var container = $(">ul", element);
    var panes = $(">ul>li", element);


    var pane_width = 0;
    var pane_count = panes.length;

    var current_pane = 0;

    $('li:nth-of-type(1)', '#carousel').addClass('current');
    $('.current .modType.departures').show().siblings('.modType').hide();
    $('.navItem.departures').addClass('selected').siblings().removeClass('selected');
    $('.pageDots .dot0').addClass('selected').siblings().removeClass('selected');


    /**
     * initial
     */
    this.init = function () {
        setPaneDimensions();

        $(window).on("load resize orientationchange", function () {
            setPaneDimensions();
        })
    };


    /**
     * set the pane dimensions and scale the container
     */
    function setPaneDimensions() {
        pane_width = element.width();
        panes.each(function () {
            $(this).width(pane_width);
            $(this).height(pane_width);
        });
        container.width(pane_width * pane_count);
    };


    /**
     * show pane by index
     */
    this.showPane = function (index, animate) {

        // between the bounds
        index = Math.max(0, Math.min(index, pane_count - 1));
        current_pane = index;
        contWidth = container.width();
        var offset = -((contWidth / pane_count) * current_pane);

        setContainerOffset(offset, animate);
        var visiblePane = $('.panel' + current_pane);
        $(visiblePane).addClass('current').siblings().removeClass('current');
        $('.current .modType.departures').show().siblings('.modType').hide();
        $('.navItem.departures').addClass('selected').siblings().removeClass('selected');
        $('.pageDots .dot' + index).addClass('selected').siblings().removeClass('selected');

        var winWidth = $(window).width();

        if (winWidth < 340) {
            if (index > 0) {
                $(visiblePane).addClass('paddedPanel').siblings().removeClass('paddedPanel');
            }
        }

    };


    function setContainerOffset(percent, animate) {
        container.removeClass("animate");

        if (animate) {
            container.addClass("animate");
        }
        container.css("left", percent + "px");

        // var panelCont = $('.panelList');

        // if (animate) {

        //     panelCont.animate({
        //         left: percent
        //     },200);


        // } else {

        //     container.css("left", percent);

        //}

    }

    this.next = function () {
        return this.showPane(current_pane + 1, true);
    };
    this.prev = function () {
        return this.showPane(current_pane - 1, true);
    };


    function handleHammer(ev) {
        // disable browser scrolling
        ev.gesture.preventDefault();

        switch (ev.type) {
        case 'dragright':
        case 'dragleft':
            // stick to the finger
            var pane_offset = -(contWidth / pane_count) * current_pane;
            var drag_offset = ((contWidth / pane_width) * ev.gesture.deltaX) / pane_count;
            // slow down at the first and last pane
            if ((current_pane == 0 && ev.gesture.direction == "right") ||
                (current_pane == pane_count - 1 && ev.gesture.direction == "left")) {
                drag_offset *= .4;
            }

            setContainerOffset(drag_offset + pane_offset);
            break;

        case 'swipeleft':
            self.next();
            ev.gesture.stopDetect();
            break;

        case 'swiperight':
            self.prev();
            ev.gesture.stopDetect();
            break;

        case 'release':
            // more then 50% moved, navigate
            if (Math.abs(ev.gesture.deltaX) > pane_width / 6) {
                if (ev.gesture.direction == 'right') {
                    self.prev();
                } else {
                    self.next();
                }
            } else {
                self.showPane(current_pane, true);
            }
            break;
        }
    }

    new Hammer(element[0], {
        dragLockToAxis: true
    }).on("release dragleft dragright swipeleft swiperight", handleHammer);
}
}